﻿#define V2
// #define VGEN

namespace GenericMethodsAndOverloading {
	class Program {
		static void m(object o) {
			Console.WriteLine("m(object o): o == {0}", o);
		}

#if VGEN
		static void m<T>(T v) {
			Console.WriteLine("m<T>(T v): typeof(T) == {0}, v == {1}", typeof(T), v);
		}
#endif

		static void m(double d) {
			Console.WriteLine("m(double d): d == {0}", d);
		}

#if V2
		static void m(int i) {
			Console.WriteLine("m(int i): i == {0}", i);
		}
#endif

		static void Main(string[] args) {
			m("hello");
			m(1.0);
			m(1);

			Console.WriteLine();

			CallM("hello");
			CallM(1.0);
			CallM(1);

			Console.WriteLine();

			CallM2("hello");
			CallM2(1.0);
			CallM2(1);
		}

		static void CallM<T>(T v) {
			Console.Write($"CallM<{typeof(T)}> calling: ");
			m(v);
		}

		static void CallM2<T>(T v) {
			Console.Write($"CallM2<{typeof(T)}> calling: ");
			m((object) v);
		}
	}
}
