﻿record class WeightlessStringPackage(string Payload) { }

record class MailDuck(string Name) {
	public void LoadPackage(dynamic package) {
		Console.WriteLine($"C#: Duck {Name} acccepted package {package}.");
	}

	public void SignalArrival() {
		Console.WriteLine($"C#: Duck {Name} generating sound: QUAAACK");
	}
}

record class MailSwan(string Name) {
	public void LoadPackage(dynamic package) {
		Console.WriteLine($"C#: Swan {Name} acccepted package {package}.");
	}

	public void SignalArrival() {
		Console.WriteLine($"C#: Swan {Name} generating sound: TSSSSS");
	}
}

class Program {
	static void Main(string[] args) {
		var duck = new MailDuck("Teri");
		duck.SignalArrival();
		var swan = new MailSwan("Bety");
		swan.SignalArrival();

		Console.WriteLine();
		var oneWordPackage = new WeightlessStringPackage("pillow");

		PostPackage(oneWordPackage, duck);
		PostPackage(oneWordPackage, swan);

		var ship = new WolfGoatCabbageShip();
		PostPackage(oneWordPackage, ship);
	}

	static void PostPackage(dynamic package, dynamic carrier) {
		Console.WriteLine("C# >>> Posting a package >>>");
		Console.WriteLine("+ Stage 1 - package loading:");
		carrier.LoadPackage(package);
		Console.WriteLine("+ Last stage - arrival:");
		carrier.SignalArrival();
		Console.WriteLine();
	}
}

record class WolfGoatCabbageShip { }